// file      : xsde/cxx/parser/validating/gmonth.hxx
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#ifndef XSDE_CXX_PARSER_VALIDATING_GMONTH_HXX
#define XSDE_CXX_PARSER_VALIDATING_GMONTH_HXX

#include <xsde/cxx/string.hxx>

#include <xsde/cxx/parser/validating/xml-schema-pskel.hxx>

namespace xsde
{
  namespace cxx
  {
    namespace parser
    {
      namespace validating
      {
#ifdef XSDE_REUSE_STYLE_MIXIN
        struct gmonth_pimpl: virtual gmonth_pskel
#else
        struct gmonth_pimpl: gmonth_pskel
#endif
        {
          virtual void
          _pre ();

          virtual void
          _characters (const ro_string&);

          virtual void
          _post ();

          virtual gmonth
          post_gmonth ();

        protected:
          string str_;
          unsigned short month_;
          bool z_;
          short zh_, zm_;
        };
      }
    }
  }
}

#endif // XSDE_CXX_PARSER_VALIDATING_GMONTH_HXX
